/************************************************************************
 *									*
 *		`bdr@r^f@botvO			*
 *									*
 *				: p[I			*
 *		t@C	: init.c				*
 *									*
 ************************************************************************/

#pragma	SECTION	PROG=init

#include "sg_cpu.h"

/*	֐	*/
static	void	check_pid(void);
static	void	set_VIC068(void);

/*=======================================================================
 |
 |		p[I
 |
 |	void	power_on()
 |
 =======================================================================*/
void	power_on(void)
{
	register word	*p;

	check_pid();		/* vZbThc`FbN */

//	*REG_WDT = 0x9d;	/* kdc_ */

	/* rq`l[NA */
//	for (p = ADR_SRAM; p < ADR_SRAM_END; p++)
//		*p = 0;

	/* fobO[h`FbN */
	if (debug_flag & DBF_DEBUGMODE)
		debug_mode = DBM_VT;

	set_VIC068();		/* uhbOUWRg[WX^ݒ */
	set_DUART();		/* ct`qsRg[WX^ݒ */

	sg_mode = SGM_PBIT;	/* POWER ON BIT Jn */

	rom_check();		/* ddoqnlT`FbN */
	ram_check();		/* rq`l`FbN */
	cpu_check();		/* bot`FbN */

	/* q`o[NA */
	for (p = GSC_RAP; p < GSC_RAP_END; p++)
		*p = 0;

	if (cpu == CPU_1)
		mbibit();	/* lah{[hahs`FbNJn */

	/* 荞݃}XN */
	mskclr();
	int_enable();

	/* frbWX^Zbg */
//	*REG_GSC_OUTPUT = 0x0001;
//	*REG_GSC_OPRATE = 0x2000;

	sg_main();		/* C */
}

/*=======================================================================
 |
 |		vZbThc`FbN
 |
 |	void	check_pid()
 |
 =======================================================================*/
static	void	check_pid(void)
{
/*@@@@@@@@@@@@*/
extern	word	test_gsc[];
cpu = CPU_1;
adr_gsc = (char *)test_gsc;
return;
/*@@@@@@@@@@@@*/
	switch (*REG_STATUS & 0x0f) {
	case 0x0f:
		cpu = CPU_1;			/* botԍZbg */
		adr_gsc = (char *)VME_GSC1;	/* frbAhXZbg */
		break;
	case 0x0e:
		cpu = CPU_2;			/* botԍZbg */
		adr_gsc = (char *)VME_GSC2;	/* frbAhXZbg */
		break;
	case 0x0d:
		cpu = CPU_3;			/* botԍZbg */
		adr_gsc = (char *)VME_GSC3;	/* frbAhXZbg */
		break;
	default:
		halt_cpu("ILLEGAL PROCESSOR ID", 100);
		break;
	}
}

/*=======================================================================
 |
 |		uhbOUWRg[WX^ݒ
 |
 |	void	set_VIC068()
 |
 =======================================================================*/
static	void	set_VIC068(void)
{
	/*	uhbOUWRg[WX^ݒl (MASTER CPU) */
	static	BYTE_REG_DATA	CPU1_VIC068[] = {
	        {REG_VIC_EGIVBR, 0x50, 100},
	        {REG_VIC_ICGSIVBR, 0x58, 100},
	        {REG_VIC_ICMSIVBR, 0x5C, 100},
	        {REG_VIC_LIVBR,  0x40, 100},
	        {REG_VIC_LICR1,  0xb2, 100},
	        {REG_VIC_LICR2,  0xb1, 100},
	        {REG_VIC_VIVR1,  0x48, 100},
	        {REG_VIC_VIVR2,  0x49, 100},
	        {REG_VIC_VIVR3,  0x4a, 100},
	        {REG_VIC_VIVR4,  0x4b, 100},
	        {REG_VIC_VIVR5,  0x4c, 100},
	        {REG_VIC_VIVR6,  0x4d, 100},
	        {REG_VIC_VIVR7,  0x4e, 100},
	        {REG_VIC_SS0CR0, 0xc0, 100},
	        {REG_VIC_SS1CR0, 0x00, 100},
	        {REG_VIC_LBTR,   0x00, 100},
	        {REG_VIC_TTR,    0x6a, 100},
	        {REG_VIC_RCR,    0x00, 100},
	        {REG_VIC_BESR,   0x80, 100},
	        {REG_VIC_ARCR,   0x60, 100}
	};

	/*	uhbOUWRg[WX^ݒl (SLAVE CPU) */
	static	BYTE_REG_DATA	CPU23_VIC068[] = {
	        {REG_VIC_EGIVBR, 0x50, 100},
	        {REG_VIC_ICGSIVBR, 0x58, 100},
	        {REG_VIC_ICMSIVBR, 0x5C, 100},
	        {REG_VIC_LIVBR,  0x40, 100},
	        {REG_VIC_LICR1,  0xb2, 100},
	        {REG_VIC_LICR2,  0xb1, 100},
	        {REG_VIC_VIVR1,  0x48, 100},
	        {REG_VIC_VIVR2,  0x49, 100},
	        {REG_VIC_VIVR3,  0x4a, 100},
	        {REG_VIC_VIVR4,  0x4b, 100},
	        {REG_VIC_VIVR5,  0x4c, 100},
	        {REG_VIC_VIVR6,  0x4d, 100},
	        {REG_VIC_VIVR7,  0x4e, 100},
	        {REG_VIC_SS0CR0, 0xc0, 100},
	        {REG_VIC_SS1CR0, 0x00, 100},
	        {REG_VIC_LBTR,   0x00, 100},
	        {REG_VIC_TTR,    0x6a, 100},
	        {REG_VIC_RCR,    0x00, 100},
	        {REG_VIC_BESR,   0x00, 100},
	        {REG_VIC_ARCR,   0x60, 100}
	};

	switch (cpu) {
	case CPU_1:
		write_byte_register(CPU1_VIC068,
			sizeof(CPU1_VIC068) / sizeof(BYTE_REG_DATA));
		break;
	default:
		write_byte_register(CPU23_VIC068,
			sizeof(CPU23_VIC068) / sizeof(BYTE_REG_DATA));
		break;
	}
}

/*=======================================================================
 |
 |		ct`qsRg[WX^̐ݒ
 |
 |	void	set_DUART()
 |
 =======================================================================*/
void	set_DUART(void)
{
	/*	ct`qsRg[WX^ݒl */
	static	BYTE_REG_DATA	DUART[] = {
		{REG_DUART_CRA,  0x0a, 100},
		{REG_DUART_CRA,  0x10, 100},
		{REG_DUART_CRA,  0x20, 100},
		{REG_DUART_CRA,  0x30, 100},
		{REG_DUART_CRA,  0x40, 100},
		{REG_DUART_CRA,  0x50, 100},
		{REG_DUART_MR1A, 0x07, 100},
		{REG_DUART_MR2A, 0x0f, 100},
		{REG_DUART_CSRA, 0xbb, 100},
		{REG_DUART_CRA,  0x05, 100},
		{REG_DUART_CRB,  0x0a, 100},
		{REG_DUART_CRB,  0x10, 100},
		{REG_DUART_CRB,  0x20, 100},
		{REG_DUART_CRB,  0x30, 100},
		{REG_DUART_CRB,  0x40, 100},
		{REG_DUART_CRB,  0x50, 100},
		{REG_DUART_MR1B, 0x17, 100},
		{REG_DUART_MR2B, 0x07, 100},
		{REG_DUART_CSRB, 0xbb, 100}
	};

	/* DUART  */
	write_byte_register(DUART,
			sizeof(DUART) / sizeof(BYTE_REG_DATA));

	/* fobO[h`FbN */
	if (debug_mode == DBM_VT) {
		/* bg|aiusjM */
//		*REG_DUART_CRB = 0x05;
		rs_IMR = 0x22;
//		*REG_DUART_IMR = rs_IMR;
	} else {
		/* bg|aiusjMs */
//		*REG_DUART_CRB = 0x02;
		rs_IMR = 0x02;
//		*REG_DUART_IMR = rs_IMR;
	}
}
